import _objectSpread from "@babel/runtime-corejs3/helpers/objectSpread2";
import _asyncToGenerator from "@babel/runtime-corejs3/helpers/asyncToGenerator";
import _slicedToArray from "@babel/runtime-corejs3/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime-corejs3/helpers/objectWithoutProperties";
var _excluded = ["content", "children", "render", "onOk", "onCancel", "onFailed"];
import _regeneratorRuntime from "@babel/runtime-corejs3/regenerator";
import React, { isValidElement, Children, useEffect, useRef, useState } from 'react';
import { createRoot } from 'react-dom/client';
import { Modal } from 'antd';
import { jsx as _jsx } from "react/jsx-runtime";

function App(_ref) {
  var content = _ref.content,
      _ref$children = _ref.children,
      children = _ref$children === void 0 ? content : _ref$children,
      render = _ref.render,
      onOk = _ref.onOk,
      onCancel = _ref.onCancel,
      onFailed = _ref.onFailed,
      rest = _objectWithoutProperties(_ref, _excluded);

  var formLikeRef = useRef();

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      visible = _useState2[0],
      setVisible = _useState2[1];

  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      confirmLoading = _useState4[0],
      setConfirmLoading = _useState4[1];

  useEffect(function () {
    // for animation
    setVisible(true);
  }, []);

  var handleOk = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      var _formLikeRef$current, _formLikeRef$current2, validateFields, _values;

      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              setConfirmLoading(true);
              _context.prev = 1;
              validateFields = ((_formLikeRef$current = formLikeRef.current) === null || _formLikeRef$current === void 0 ? void 0 : _formLikeRef$current.validateFieldsReturnFormatValue) || ((_formLikeRef$current2 = formLikeRef.current) === null || _formLikeRef$current2 === void 0 ? void 0 : _formLikeRef$current2.validateFields);
              _context.next = 5;
              return validateFields === null || validateFields === void 0 ? void 0 : validateFields();

            case 5:
              _values = _context.sent;
              _context.next = 8;
              return onOk === null || onOk === void 0 ? void 0 : onOk(_values);

            case 8:
              setVisible(false);
              _context.next = 14;
              break;

            case 11:
              _context.prev = 11;
              _context.t0 = _context["catch"](1);
              // console.error(error);
              onFailed === null || onFailed === void 0 ? void 0 : onFailed(_context.t0); // throw error;

            case 14:
              _context.prev = 14;
              setConfirmLoading(false);
              return _context.finish(14);

            case 17:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[1, 11, 14, 17]]);
    }));

    return function handleOk() {
      return _ref2.apply(this, arguments);
    };
  }(); // const handleDeny = async () => {
  //   setConfirmLoading(true);
  //   try {
  //     const validateFields =
  //       formLikeRef.current?.validateFieldsReturnFormatValue || formLikeRef.current?.validateFields;
  //     const values = await validateFields?.();
  //     await onDeny?.(values);
  //     setVisible(false);
  //   } catch (error) {
  //     onFailed?.(error);
  //     console.error(error);
  //     // throw error;
  //   } finally {
  //     setConfirmLoading(false);
  //   }
  // };


  var handleCancel = function handleCancel(e) {
    setVisible(false);
    onCancel === null || onCancel === void 0 ? void 0 : onCancel(e);
  };

  var renderPropChildren = function renderPropChildren() {
    if (render) return render(formLikeRef);
    var attached = false;
    return Children.map(children, function (child) {
      if (! /*#__PURE__*/isValidElement(child)) {
        return child;
      }

      if (attached) return child;

      var childProps = _objectSpread(_objectSpread({}, child.props), {}, {
        ref: formLikeRef
      });

      attached = true;
      return /*#__PURE__*/React.cloneElement(child, childProps);
    });
  };

  return /*#__PURE__*/_jsx(Modal, _objectSpread(_objectSpread({}, rest), {}, {
    // todo context value and locale
    // todo extra footer buttons
    confirmLoading: confirmLoading,
    onCancel: handleCancel,
    onOk: handleOk // footer={[
    //   hideCancel || (
    //     <Button key="cancel" onClick={handleCancel}>
    //       {rest?.cancelText || '取消'}
    //     </Button>
    //   ),
    //   onDeny && (
    //     <Button key="deny" type="primary" danger loading={confirmLoading} onClick={handleDeny}>
    //       {denyText || '驳回'}
    //     </Button>
    //   ),
    //   hideOk || (
    //     <Button key="ok" type="primary" loading={confirmLoading} onClick={handleOk}>
    //       {rest?.okText || '确定'}
    //     </Button>
    //   ),
    // ]}
    ,
    destroyOnClose: true,
    visible: visible,
    children: renderPropChildren()
  }));
}
/**
 * @description Create a one-time modal dialog dynamically without maintenance loading and visible.
 */


export default function createModal(params) {
  /**
   * https://github.com/ant-design/ant-design/issues/23623
   *
   * Sync render blocks React event. Let's make this async.
   */
  setTimeout(function () {
    var div = document.createElement('div');
    document.body.appendChild(div);
    div.setAttribute('role', 'Dynamically created modal');
    var root = createRoot(div);

    function destory() {
      setTimeout(function () {
        root.unmount();
        document.body.removeChild(div);
      }); // console.log('destoryed modal');
    }

    root.render(
    /*#__PURE__*/
    // <RootContainer>
    _jsx(App, _objectSpread({
      afterClose: destory
    }, params)) // </RootContainer>
    );
  });
}